# This imports all the layers for "sk8-framer" into sk8FramerLayers
PSD = Framer.Importer.load "imported/sk8-framer"

for layerGroupName of PSD
  window[layerGroupName] = PSD[layerGroupName]

for layerGroupName of PSD
  PSD[layerGroupName].originalFrame = window[layerGroupName].frame
 
 map_range = (value, low1, high1, low2, high2) ->
  if value < low1
    low2
  else if value > high1
    high2
  else
    low2 + (high2 - low2) * (value - low1) / (high1 - low1)
 
smoothSprint = 'spring(300,60,20)'
bouncySprint = 'spring(380,25,0)'
quickSprint = 'spring(300,50,35)'
circleSprint = 'spring(200,35,10)'

setupScene = () -> 
	ddetails.visible = false
	dshadow.opacity = 0
	s2logo.opacity = 0
	s2title.x = s2title.originalFrame.x + 950
	s2price.x = s2price.originalFrame.x + 750
	s2deck.x = s2deck.originalFrame.x + 750
	s2logo.x = s2logo.originalFrame.x + 350
	
	
setupScene()

clickMeLayer = new Layer({
    y:650, 
    height:700, 
    width:750, 
    opacity:0, 
    backgroundColor:"blue"
})

openDetail = ->
	ddetails.visible = true
	ddetails.y = ddetails.originalFrame.y
	detailbg.y = detailbg.originalFrame.y + detailbg.height
	dtxt1.opacity = 0
	dtxt2.opacity = 0
	dtxt1.y = dtxt1.originalFrame.y + 200
	dtxt2.y = dtxt2.originalFrame.y + 200
	butbag.y = butbag.originalFrame.y + 200
	butbuy.y = butbag.originalFrame.y + 200
	
	dshadow.animate
		 properties: 
		    opacity:1
		 curve: smoothSprint
	
	deck01.animate
		 properties: 
		    y: deck01.originalFrame.y - 394
		 curve: smoothSprint
	deck02.animate
		 properties: 
		    y: deck02.originalFrame.y - 394
		 curve: smoothSprint
	detailbg.animate
		 properties: 
		    y: detailbg.originalFrame.y
		 curve: smoothSprint
	dtxt1.animate
		 delay:0.2
		 properties: 
		    y: dtxt1.originalFrame.y
		    opacity:1
		 curve: smoothSprint
	dtxt2.animate
		 delay:0.3
		 properties: 
		    y: dtxt2.originalFrame.y
		    opacity:1
		 curve: smoothSprint
	butbag.animate
		 delay:0.6
		 properties: 
		    y: butbag.originalFrame.y
		 curve: smoothSprint
	butbuy.animate
		 delay:0.7
		 properties: 
		    y: butbuy.originalFrame.y
		 curve: smoothSprint
		
closeDetail = ->
	dshadow.animate
		 properties: 
		    opacity:0
		 curve: smoothSprint
		 
	deck01.animate
		 properties: 
		    y: deck01.originalFrame.y
		 curve: quickSprint
	deck02.animate
		 properties: 
		    y: deck02.originalFrame.y
		 curve: quickSprint
	ddetails.animate
		 properties: 
		    y: ddetails.originalFrame.y + 394
		 curve: quickSprint

	
toggler = Utils.toggle(openDetail, closeDetail)

clickMeLayer.on Events.Click, (event, layer) ->
  changeS = toggler()
  changeS()

dragMeLayer = new Layer({
    x:0, 
    height:650, 
    width:750 * 2, 
    opacity:0, 
    backgroundColor:"red"
})
dragMeLayer.draggable.enabled = true
dragMeLayer.draggable.speedY = 0

dragMeLayer.on Events.DragMove, (event, layer) ->
	s1logo.opacity = map_range(dragMeLayer.x, -300, 0, 0, 10) / 10
	s1title.x = map_range(dragMeLayer.x, -750, 0, s1title.originalFrame.x - 950, s1title.originalFrame.x)
	s1price.x = map_range(dragMeLayer.x, -750, 0, s1price.originalFrame.x - 450, s1price.originalFrame.x)
	s1deck.x = map_range(dragMeLayer.x, -750, 0, s1deck.originalFrame.x - 750, s1deck.originalFrame.x)
	s1logo.x = map_range(dragMeLayer.x, -750, 0, s1logo.originalFrame.x - 350, s1logo.originalFrame.x)
	
	s2logo.opacity = map_range(dragMeLayer.x, -750, -400, 10, 0) / 10
	s2title.x = map_range(dragMeLayer.x, -750, 0, s2title.originalFrame.x, s2title.originalFrame.x + 1450)
	s2price.x = map_range(dragMeLayer.x, -750, 0, s2price.originalFrame.x, s2price.originalFrame.x + 950)
	s2deck.x = map_range(dragMeLayer.x, -750, 0, s2deck.originalFrame.x, s2deck.originalFrame.x + 750)
	s2logo.x = map_range(dragMeLayer.x, -750, 0, s2logo.originalFrame.x, s2logo.originalFrame.x + 350)
	
	if dragMeLayer.x < -750
		s2logo.opacity = map_range(dragMeLayer.x, -1050, -750, 0, 10) / 10
		s2title.x = map_range(dragMeLayer.x, -1500, -750, s2title.originalFrame.x - 950, s2title.originalFrame.x)
		s2price.x = map_range(dragMeLayer.x, -1500, -750, s2price.originalFrame.x - 450, s2price.originalFrame.x)
		s2deck.x = map_range(dragMeLayer.x, -1500, -750, s2deck.originalFrame.x - 750, s2deck.originalFrame.x)
		s2logo.x = map_range(dragMeLayer.x, -1500, -750, s2logo.originalFrame.x - 350, s2logo.originalFrame.x)

dragMeLayer.on Events.DragEnd, (event, layer) ->
	if dragMeLayer.x > 0
		dragMeLayer.x = 0
	if dragMeLayer.x < -750
		dragMeLayer.x = -750
	if dragMeLayer.x > -400
		dragMeLayer.x = 0
		s1title.animate
		 properties: 
		    x: s1title.originalFrame.x
		 curve: bouncySprint
		
		s1price.animate
		 properties: 
		    x: s1price.originalFrame.x
		 curve: bouncySprint
		
		s1deck.animate
		 properties: 
		    x: s1deck.originalFrame.x
		 curve: bouncySprint
		
		s1logo.animate
		 properties: 
		    x: s1logo.originalFrame.x
		    opacity:1
		 curve: bouncySprint
		 
		s2title.animate
		 properties: 
		    x: s2title.originalFrame.x + 1450
		 curve: bouncySprint
		
		s2price.animate
		 properties: 
		    x: s2price.originalFrame.x + 950
		 curve: bouncySprint
		
		s2deck.animate
		 properties: 
		    x: s2deck.originalFrame.x + 750
		 curve: bouncySprint
		
		s2logo.animate
		 properties: 
		    x: s2logo.originalFrame.x + 350
		    opacity:0
		 curve: bouncySprint
		 
	if dragMeLayer.x < -400 
		dragMeLayer.x = -750
		s1title.animate
		 properties: 
		    x: s1title.originalFrame.x - 950
		 curve: bouncySprint
		
		s1price.animate
		 properties: 
		    x: s1price.originalFrame.x - 450
		 curve: bouncySprint
		
		s1deck.animate
		 properties: 
		    x: s1deck.originalFrame.x - 750
		 curve: bouncySprint
		
		s1logo.animate
		 properties: 
		    x: s1logo.originalFrame.x - 350
		    opacity:0
		 curve: bouncySprint
		 
		s2title.animate
		 properties: 
		    x: s2title.originalFrame.x 
		 curve: bouncySprint
		
		s2price.animate
		 properties: 
		    x: s2price.originalFrame.x 
		 curve: bouncySprint
		
		s2deck.animate
		 properties: 
		    x: s2deck.originalFrame.x 
		 curve: bouncySprint
		
		s2logo.animate
		 properties: 
		    x: s2logo.originalFrame.x 
		    opacity:1
		 curve: bouncySprint

	